SystemOrganization addCategory: #ConfigurationOfApplicationSecurity!

Object subclass: #ConfigurationOfApplicationSecurity
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfApplicationSecurity'!

!ConfigurationOfApplicationSecurity class methodsFor: 'development support' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfApplicationSecurity class methodsFor: 'private' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfApplicationSecurity class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/22/2014 06:05'!
catalogChangeLog
		
	^ ''! !

!ConfigurationOfApplicationSecurity class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/22/2014 06:01'!
catalogContactInfo
	^ 'hernan.morales@gmail.com'! !

!ConfigurationOfApplicationSecurity class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/22/2014 06:04'!
catalogDescription

	^ 'ApplicationSecurity provides a domain-independent Security Model.'! !

!ConfigurationOfApplicationSecurity class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/22/2014 06:05'!
catalogKeyClassesAndExample

	^ ''! !

!ConfigurationOfApplicationSecurity class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/22/2014 06:03'!
catalogKeywords
	^ #(security encryption decryption sha checkpoint authorization authentication rbac acl nacl)! !

!ConfigurationOfApplicationSecurity class methodsFor: 'private' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfApplicationSecurity class methodsFor: 'private' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfApplicationSecurity class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfApplicationSecurity class methodsFor: 'loading' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfApplicationSecurity class methodsFor: 'loading' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfApplicationSecurity class methodsFor: 'loading' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfApplicationSecurity class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
project

	^self new project! !

!ConfigurationOfApplicationSecurity class methodsFor: 'development support' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfApplicationSecurity methodsFor: 'baselines' stamp: 'HernanMoralesDurand 1/29/2014 12:19'!
baseline10: spec
    <version: '1.0-baseline'>
    
    spec for: #common do: [
        spec blessing: #baseline.
        spec description: 'First release'.
        spec repository: 'http://www.smalltalkhub.com/mc/hernan/ApplicationSecurity/main'.
        self
		specForGrease: spec;
		specForNacl: spec.
        spec package: 'ApplicationSecurity'		with: [ spec requires: #('Grease' 'Nacl') ].
        spec package: 'ApplicationSecurityTest'	with: [ spec requires: 'ApplicationSecurity' ].
	
	spec
		group: 'default' 	with: #('Core' 'Tests');
		group: 'Core' 		with: #('ApplicationSecurity');
		group: 'Tests' 		with: #('ApplicationSecurity' 'ApplicationSecurityTest') ]
        ! !

!ConfigurationOfApplicationSecurity methodsFor: 'baselines' stamp: 'HernanMoralesDurand 10/13/2014 18:23'!
baseline12: spec
	<version: '1.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/ApplicationSecurity/main'.
		spec 
			project: 'Grease' with: [
				spec
					className: #ConfigurationOfGrease;
					versionString: #'stable';
					repository: 'http://www.smalltalkhub.com/mc/hernan/Grease/main' ];
			project: 'Nacl' with: [
				spec
					className: #ConfigurationOfNacl;
					versionString: #'stable';
					repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main' ].
		spec 
			package: 'ApplicationSecurity' with: [
				spec requires: #('Grease' 'Nacl' ). ];
			package: 'ApplicationSecurityTest' with: [
				spec requires: #('ApplicationSecurity' ). ].
		spec 
			group: 'default' with: #('Core' 'Tests' );
			group: 'Core' with: #('ApplicationSecurity' );
			group: 'Tests' with: #('ApplicationSecurity' 'ApplicationSecurityTest' ). ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'baselines' stamp: 'HernanMoralesDurand 7/14/2015 12:40'!
baseline13: spec
	<version: '1.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/ApplicationSecurity/main'.
		spec 
			project: 'Grease' with: [
				spec
					className: #ConfigurationOfGrease;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main/' ];
			project: 'Nacl' with: [
				spec
					className: #ConfigurationOfNacl;
					versionString: #'stable';
					repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main' ].
		spec 
			package: 'ApplicationSecurity' with: [
				spec requires: #('Grease' 'Nacl' ). ];
			package: 'ApplicationSecurityTest' with: [
				spec requires: #('ApplicationSecurity' ). ].
		spec 
			group: 'default' with: #('Core' 'Tests' );
			group: 'Core' with: #('ApplicationSecurity' );
			group: 'Tests' with: #('ApplicationSecurity' 'ApplicationSecurityTest' ). ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'baselines' stamp: 'HernanMoralesDurand 2/4/2016 17:23'!
baseline14: spec
	<version: '1.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/ApplicationSecurity/main'.
		spec 
			project: 'Grease' with: [
				spec
					className: #ConfigurationOfGrease;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main/' ];
			project: 'Nacl' with: [
				spec
					className: #ConfigurationOfNacl;
					versionString: #'stable';
					repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main' ].
		spec 
			package: 'ApplicationSecurity' with: [
				spec requires: #('Grease' 'Nacl' ). ];
			package: 'ApplicationSecurityTest' with: [
				spec requires: #('ApplicationSecurity' ). ].
		spec 
			group: 'default' with: #('Core' 'Tests' );
			group: 'Core' with: #('ApplicationSecurity' );
			group: 'Tests' with: #('ApplicationSecurity' 'ApplicationSecurityTest' ). ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'baselines' stamp: 'HernanMoralesDurand 2/4/2016 17:22'!
baseline15: spec
	<version: '1.5-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/ApplicationSecurity/main'.
		spec 
			project: 'Grease' with: [
				spec
					className: #ConfigurationOfGrease;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo50/main/' ];
			project: 'Nacl' with: [
				spec
					className: #ConfigurationOfNacl;
					versionString: '1.1';
					repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo50/main' ].
		spec 
			package: 'ApplicationSecurity' with: [
				spec requires: #('Grease' 'Nacl' ). ];
			package: 'ApplicationSecurityTest' with: [
				spec requires: #('ApplicationSecurity' ). ].
		spec 
			group: 'default' with: #('Core' 'Tests' );
			group: 'Core' with: #('ApplicationSecurity' );
			group: 'Tests' with: #('ApplicationSecurity' 'ApplicationSecurityTest' ). ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfApplicationSecurity methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 2/4/2016 17:20'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.5-baseline'.
! !

!ConfigurationOfApplicationSecurity methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2014 05:31'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfApplicationSecurity methodsFor: 'external projects' stamp: 'HernanMoralesDurand 1/22/2014 06:05'!
specForGrease: spec

	spec project: 'Grease' with: [ spec
		className: 'ConfigurationOfGrease';
		version: #stable;
		repository: 'http://www.smalltalkhub.com/mc/hernan/Grease/main' ]
		
! !

!ConfigurationOfApplicationSecurity methodsFor: 'external projects' stamp: 'HernanMoralesDurand 1/29/2014 11:59'!
specForNacl: spec

	spec project: 'Nacl' with: [ spec
		className: 'ConfigurationOfNacl';
		version: #stable;
		repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main' ]
		
! !

!ConfigurationOfApplicationSecurity methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 12/24/2015 01:24'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.3'.
	spec for: #'pharo4.x' version: '1.4'.
	spec for: #'pharo5.x' version: '1.5'.! !

!ConfigurationOfApplicationSecurity methodsFor: 'versions' stamp: 'HernanMoralesDurand 3/27/2014 20:40'!
version10: spec
    "The name for this version is solely defined by the following pragma:"
    <version: '1.0' imports: #('1.0-baseline') >
    "Baselines are used to define more complex setups for your project.
    If you want to use external projects and have fine-graind control of the dependencies between packages use the #imports: part.
    See the #baseline10: for more details."
    "Using #for:do: with the #common release specifier the following version declaration is valid for all platforms."
    spec for: #common do: [
        spec
            blessing: #release;       
            description: 'Version 1.0 the current stable release';
            author: 'Hernan Morales Durand';
            timestamp: '2013-05-01'.
        spec
		project: 'Grease'						with: #stable;
		project: 'Nacl'							with: #stable;
            package: 'ApplicationSecurity'			with: 'ApplicationSecurity-HernanMoralesDurand.55';
            package: 'ApplicationSecurityTest'		with: 'ApplicationSecurityTest-HernanMoralesDurand.24' ].

! !

!ConfigurationOfApplicationSecurity methodsFor: 'versions' stamp: 'HernanMoralesDurand 10/13/2014 18:24'!
version11: spec
	<version: '1.1' imports: #('1.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.1'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '10/13/2014 18:24'.
		spec 
			project: 'Grease' with: '1.2';
			project: 'Nacl' with: '1.0'.
		spec 
			package: 'ApplicationSecurity' with: 'ApplicationSecurity-HernanMoralesDurand.59';
			package: 'ApplicationSecurityTest' with: 'ApplicationSecurityTest-HernanMoralesDurand.27'. ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'versions' stamp: 'HernanMoralesDurand 10/13/2014 18:41'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.2'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '10/13/2014 18:26'.
		spec 
			project: 'Grease' with: '1.2';
			project: 'Nacl' with: '1.0'.
		spec 
			package: 'ApplicationSecurity' with: 'ApplicationSecurity-HernanMoralesDurand.60';
			package: 'ApplicationSecurityTest' with: 'ApplicationSecurityTest-HernanMoralesDurand.27'. ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'versions' stamp: 'HernanMoralesDurand 10/13/2014 19:43'!
version13: spec
	<version: '1.3' imports: #('1.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.3'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '10/13/2014 19:43'.
		spec 
			project: 'Grease' with: '1.2';
			project: 'Nacl' with: '1.0'.
		spec 
			package: 'ApplicationSecurity' with: 'ApplicationSecurity-HernanMoralesDurand.61';
			package: 'ApplicationSecurityTest' with: 'ApplicationSecurityTest-HernanMoralesDurand.28'. ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'versions' stamp: 'HernanMoralesDurand 2/4/2016 17:24'!
version14: spec
	<version: '1.4' imports: #('1.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.4'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '14/7/2015 12:43'.
		spec 
			project: 'Grease' with: '1.1.9';
			project: 'Nacl' with: '1.1'.
		spec 
			package: 'ApplicationSecurity' with: 'ApplicationSecurity-HernanMoralesDurand.61';
			package: 'ApplicationSecurityTest' with: 'ApplicationSecurityTest-HernanMoralesDurand.28'. ].
! !

!ConfigurationOfApplicationSecurity methodsFor: 'versions' stamp: 'HernanMoralesDurand 12/24/2015 01:38'!
version15: spec
	<version: '1.5' imports: #('1.4-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.5'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '14/7/2015 12:43'.
		spec 
			project: 'Grease' with: '1.2.2';
			project: 'Nacl' with: '1.0'.
		spec 
			package: 'ApplicationSecurity' with: 'ApplicationSecurity-HernanMoralesDurand.61';
			package: 'ApplicationSecurityTest' with: 'ApplicationSecurityTest-HernanMoralesDurand.28'. ].
! !
